#include <stdio.h>
#include <stdlib.h>
#include "standard.h"
#include "config.h"
#include "emul.h"
#include "solver.h"
#include "clpr_misc.h"
#include "main.h"

/*---------------------------------------------------------------------------*/
/*
** This function performs the necessary initialisations for the CLPR solver.
*/
void CLPR_init(void)
{
	CLPR_init_solver();
	CLPR_init_solver_goal();

	/* get some memory for the CLP(R) trail */
	CLPR_trail = (CLPR_int **) malloc(DEF_TRAIL_SZ * sizeof(CLPR_int *));
	if (!CLPR_trail) {
		CLPR_fatal("CLPR_init: cannot allocate CLPR_trail: malloc failed");
	}
	CLPR_trtop = 0;
	CLPR_stamp = -1;

	/* initialise the CLP(R) streams */
	CLPR_error_stream = stderr;
	CLPR_outfile = stderr;
	CLPR_dumpF = stderr;
}
