/***************************************************************
 *  CLP(R)                                                     *
 *  (c) Copyright International Business Machines Corporation  *
 *  (1989) 1991, 1992 All Rights Reserved                      *
 *  Version: 1.2                                               *
 *  File: lib.h                                                *
 ***************************************************************/

#include "standard.h"

#ifndef LIB_H
#define LIB_H
typedef struct {
	CLPR_int (*func) ();
	CLPR_int arity;
	char *str;
	CLPR_int val;
} SPNODE;

extern CLPR_int CLPR_do_history(void);
extern CLPR_int CLPR_do_history1(CLPR_int *t);
extern CLPR_int do_true();
extern CLPR_int CLPR_do_tell(CLPR_int *t);
extern CLPR_int CLPR_do_telling(CLPR_int *t);
extern CLPR_int CLPR_do_told(void);
extern CLPR_int CLPR_do_see(CLPR_int *t);
extern CLPR_int CLPR_do_seeing(CLPR_int *t);
extern CLPR_int CLPR_do_seen(CLPR_int *t);
extern CLPR_int CLPR_do_consult(CLPR_int *t);
extern CLPR_int CLPR_do_reconsult(CLPR_int *t);
extern CLPR_int CLPR_do_listing(void);
extern CLPR_int CLPR_do_listing1(CLPR_int *t);
extern CLPR_int CLPR_do_clisting1(CLPR_int *t);
extern CLPR_int CLPR_do_asserta(CLPR_int *t);
extern CLPR_int CLPR_do_assertz(CLPR_int *t);
extern CLPR_int CLPR_do_fasserta(CLPR_int *t);
extern CLPR_int CLPR_do_fassertz(CLPR_int *t);
extern CLPR_int CLPR_do_retractall(void);
extern CLPR_int CLPR_do_nl(void);
extern CLPR_int CLPR_do_flush(void);
extern CLPR_int CLPR_do_oracle(CLPR_int *t1, CLPR_int *t2, CLPR_int *t3);
extern CLPR_int CLPR_do_pipe(CLPR_int *t);
extern CLPR_int CLPR_do_fork(void);
extern CLPR_int CLPR_do_edit(CLPR_int *t);
extern CLPR_int CLPR_do_more(CLPR_int *t);
extern CLPR_int CLPR_do_halt(void);
extern CLPR_int CLPR_do_abort(void);
extern CLPR_int CLPR_do_implicit(void);
extern CLPR_int CLPR_do_no_implicit(void);
extern CLPR_int CLPR_do_partial_implicit(void);
extern CLPR_int CLPR_do_sh(void);
extern CLPR_int CLPR_do_csh(void);
extern CLPR_int CLPR_do_nonground(CLPR_int *t);
extern CLPR_int CLPR_do_ground(CLPR_int *t);
extern CLPR_int CLPR_do_nonvar(CLPR_int *t);
extern CLPR_int CLPR_do_var(CLPR_int *t);
extern CLPR_int CLPR_do_univ(CLPR_int *t1, CLPR_int *t2);
extern CLPR_int CLPR_do_occurs(CLPR_int *t1, CLPR_int *t2);
extern CLPR_int CLPR_do_eqeq(CLPR_int *t1, CLPR_int *t2);
extern CLPR_int CLPR_do_atom(CLPR_int *t);
extern CLPR_int CLPR_do_atomic(CLPR_int *t);
extern CLPR_int CLPR_do_functor1(CLPR_int *t);
extern CLPR_int CLPR_do_arithmetic(CLPR_int *t);
extern CLPR_int CLPR_do_rand(CLPR_int *t);
extern CLPR_int CLPR_do_srand(CLPR_int *t);
extern CLPR_int CLPR_do_nl(void);
extern CLPR_int CLPR_do_dynamic(CLPR_int *t1, CLPR_int *t2);
extern CLPR_int CLPR_do_op3(CLPR_int *t1, CLPR_int *t2, CLPR_int *t3);
extern CLPR_int CLPR_do_prot(CLPR_int *t1, CLPR_int *t2);
extern CLPR_int CLPR_do_hide(CLPR_int *t1, CLPR_int *t2);
extern CLPR_int CLPR_do_warning(CLPR_int *t);
extern CLPR_int CLPR_do_codegen_debug(void);
extern CLPR_int CLPR_do_codegen_nodebug(void);
extern CLPR_int CLPR_do_spy(void);
extern CLPR_int CLPR_do_nospy(void);
extern CLPR_int CLPR_do_spy2(CLPR_int *t1, CLPR_int *t2);
extern CLPR_int CLPR_do_nospy2(CLPR_int *t1, CLPR_int *t2);
extern CLPR_int CLPR_do_trace(void);
extern CLPR_int CLPR_do_notrace(void);
extern CLPR_int CLPR_do_clam_trace(void);
extern CLPR_int CLPR_do_clam_notrace(void);
extern CLPR_int CLPR_do_debugging(void);
extern CLPR_int CLPR_do_floor(CLPR_int *t1, CLPR_int *t2);

extern CLPR_int CLPR_do_ztime(void);
extern CLPR_int CLPR_do_ctime(CLPR_int *t);
extern CLPR_int CLPR_do_compile(CLPR_int *t1, CLPR_int *t2);
extern CLPR_int CLPR_do_e_stats(void);
extern CLPR_int CLPR_do_s_stats(void);
extern CLPR_int CLPR_do_stats(void);
extern CLPR_int CLPR_do_dump_tableaus(void);

extern CLPR_int CLPR_do_dump3(CLPR_int *t1, CLPR_int *t2, CLPR_int *t3);
extern CLPR_int CLPR_do_dump2(CLPR_int *t1, CLPR_int *t2);
extern CLPR_int CLPR_do_functor3(CLPR_int *t1, CLPR_int *t2, CLPR_int *t3);
extern CLPR_int CLPR_do_arg(CLPR_int *t1, CLPR_int *t2, CLPR_int *t3);
extern CLPR_int CLPR_do_replace_arg(CLPR_int *t1, CLPR_int *t2, CLPR_int *t3);

extern CLPR_int CLPR_do_asm_code_1(CLPR_int *t);
extern CLPR_int CLPR_do_asm_code_2(CLPR_int *t, CLPR_int *t1);
extern CLPR_int CLPR_do_asm_code_3(CLPR_int *t, CLPR_int *t1, CLPR_int *t2);
extern CLPR_int CLPR_do_asm_code_4(CLPR_int *t, CLPR_int *t1, CLPR_int *t2, CLPR_int *t3);
extern CLPR_int CLPR_do_asm_label(CLPR_int *t);
extern CLPR_int CLPR_do_asm_list(CLPR_int *t1, CLPR_int *t2);
extern CLPR_int CLPR_do_asm_call(CLPR_int *t);
extern CLPR_int CLPR_do_asm_resolve(void);

extern CLPR_int CLPR_do_style_check(CLPR_int *t);
extern CLPR_int CLPR_do_clear_style(void);
extern CLPR_int CLPR_do_counter_value(CLPR_int *t1, CLPR_int *t2);
extern CLPR_int CLPR_do_set_counter(CLPR_int *t1, CLPR_int *t2);
extern CLPR_int CLPR_do_add_counter(CLPR_int *t1, CLPR_int *t2);
extern CLPR_int CLPR_do_atom_printf(CLPR_int *t1, CLPR_int *t2, CLPR_int *t3);
extern CLPR_int CLPR_do_new_constant(CLPR_int *t1, CLPR_int *t2);
#endif
