/***************************************************************
 *  CLP(R)                                                     *
 *  (c) Copyright International Business Machines Corporation  *
 *  (1989) 1991, 1992 All Rights Reserved                      *
 *  Version: 1.2                                               *
 *  File: opcodes.h                                            *
 ***************************************************************/

#include "standard.h"

#define MAX_OPCODE      (180)

#define BADINST         (0)
#define NOOP			(1)
#define CALLP           (2)
#define JUMP            (3)
#define PROCEED         (4)
#define CALLX           (5)
#define JUMPX           (6)
#define UNI2TTVAR       (7)
#define UNI2PTVAR       (8)
#define UNI2TPVAR       (9)
#define UNI2PPVAR       (10)
#define UNILIST         (11)
#define UNISTR          (12)
#define SWITCHONTYPE    (13)
#define SWITCHONCONFUNC (14)
#define SWITCHONNIL     (15)
#define SWITCHONDOT     (16)
#define SWITCHONCON     (17)
#define SWITCH2ONCON    (18)
#define SWITCHONFUNC    (19)
#define SWITCH2ONFUNC   (20)
#define SWITCHONREAL    (21)
#define SWITCH2ONREAL   (22)
#define GETPVAR         (23)
#define GETPVAL         (24)
#define GETTVAR         (25)
#define GETTVAL         (26)
#define GETSTR          (27)
#define GETLIST         (28)
#define GETCON          (29)
#define GETNIL          (30)
#define GET1PVAR        (31)
#define GET1PVAL        (32)
#define GET1TVAR        (33)
#define GET1TVAL        (34)
#define GET1STR         (35)
#define GET1LIST        (36)
#define GET1CON         (37)
#define GET1NIL         (38)
#define GET2PVAR        (39)
#define GET2PVAL        (40)
#define GET2TVAR        (41)
#define GET2TVAL        (42)
#define GET2STR         (43)
#define GET2LIST        (44)
#define GET2CON         (45)
#define GET2NIL         (46)
#define GET3PVAR        (47)
#define GET3PVAL        (48)
#define GET3TVAR        (49)
#define GET3TVAL        (50)
#define GET3STR         (51)
#define GET3LIST        (52)
#define GET3CON         (53)
#define GET3NIL         (54)
#define UNITVAR         (55)
#define UNIT1VAR        (56)
#define UNIT2VAR        (57)
#define UNIT3VAR        (58)
#define UNIVOID         (59)
#define UNITVAL         (60)
#define UNIPVAR         (61)
#define UNIPVAL         (62)
#define UNICON          (63)
#define UNINIL          (64)
#define PUTPVAR         (65)
#define PUTPVAL         (66)
#define PUTUVAL         (67)
#define PUTTVAR         (68)
#define PUTTVAL         (69)
#define PUTSTR          (70)
#define PUTLIST         (71)
#define PUTCON          (72)
#define PUTNIL          (73)
#define BLDPVAR         (74)
#define BLDPVAL         (75)
#define BLDTVAR         (76)
#define BLDVOID         (77)
#define BLDTVAL         (78)
#define BLDCON          (79)
#define BLDNIL          (80)
#define BLDLIST         (81)
#define BLDSTR          (82)
#define SAVE            (83)
#define RESTORE         (84)
#define CRESTORE        (85)
#define TRY             (86)
#define RETRY           (87)
#define TRUST           (88)
#define FASTCUT         (89)
#define SAVECURCP       (90)
#define SAVECUT         (91)
#define DOCUT           (92)
#define REGINIT         (93)
#define ADD1PFVAR       (94)
#define ADDPFVAR        (95)
#define ADD1PFVAL       (96)
#define ADDPFVAL        (97)
#define ADDT1PFVAR      (98)
#define ADDTPFVAR       (99)
#define ADDT1PFVAL      (100)
#define ADDTPFVAL       (101)
#define INITPF          (102)
#define INIT0PF         (103)
#define SOLVE_PF0       (104)
#define SOLVE_GT0       (105)
#define SOLVE_GE0       (106)
#define PUTPNUM         (107)
#define PUTTNUM         (108)
#define GETPNUM         (109)
#define GETTNUM         (110)
#define BLDNUM          (111)
#define UNINUM          (112)
#define SOLVE_MULT      (113)
#define SOLVE_MULT1     (114)
#define SOLVE_MIN       (115)
#define SOLVE_MAX       (116)
#define SOLVE_POW       (117)
#define SOLVE_ABS       (118)
#define SOLVE_SIN       (119)
#define SOLVE_COS       (120)

#define RETRACT         (122)
#define ROOLE           (123)
#define SPCALL          (124)
#define READ            (125)
#define READREG         (126)
#define PRINT           (127)
#define PRINTF          (128)
#define DUMP            (129)
#define DBGENTRY        (130)
#define FFAIL           (131)
#define GFAIL           (132)
#define HALT            (133)
#define SOLVE_EVAL      (134)
#define DIRSAVECUT      (135)
#define JZF             (136)
#define LITF            (137)
#define SUBF            (138)
#define JGF             (139)
#define STF             (141)
#define MVF             (142)
#define LDF             (143)
#define ADDF            (144)
#define GETF            (145)
#define PUTF            (146)
#define MULF            (147)
#define DIVF            (148)

#define RETRACT_AGAIN	(150)
#define ASSERT			(151)
#define DYNAMIC_TRY		(152)
#define DYNAMIC_0_TRY	(153)
#define DYN_CALL		(154)
#define DYN_JUMP		(155)

#define ROOLE_AGAIN     (156)

#define UNIVOIDN        (157)
#define PUTPVALN        (158)
#define PUTPVARN        (159)
#define BLDTVALN        (160)
#define BLDPVALN        (161)
#define BLDVOIDN        (162)
#define UNI2TVVAR       (163)
#define UNI2VTVAR       (164)
#define UNI2PVVAR       (165)
#define UNI2VPVAR       (166)
#define ENTERSWTYPE     (167)
#define ENTERSWCON      (168)
#define ENTERSWFUNC     (169)
#define ENTERSWREAL     (170)
#define ENTERTRYELSE    (171)
#define ENTERSWCONFUNC  (172)

#define SAVEPREVCP      (173)
#define JUMPI			(174)
#define CALLI			(175)

#define SOLVE_ARCSIN	(176)
#define SOLVE_ARCCOS	(177)



