/***************************************************************
 *  CLP(R)                                                     *
 *  (c) Copyright International Business Machines Corporation  *
 *  (1989) 1991, 1992 All Rights Reserved                      *
 *  Version: 1.2                                               *
 *  File: standard.h                                           *
 ***************************************************************/

#ifndef STANDARD_H
#define STANDARD_H

#include <stdio.h>
#include <math.h>
#include <limits.h>

/* the code assumes that CLPR_int is the same size as a pointer */
#ifdef __alpha__
typedef long CLPR_int;
typedef unsigned long CLPR_unsigned;
#else
typedef int CLPR_int;
typedef unsigned CLPR_unsigned;
#endif

#define CLPR_WORDSIZE ((int) (sizeof(CLPR_int) * CHAR_BIT))

extern char *CLPR_emalloc(CLPR_int n);
extern CLPR_int *CLPR_alloc_mem(CLPR_int n);
extern CLPR_int *CLPR_findbind(CLPR_int *x);

#define MAX_MESSAGE (256)
#define MAX_STREAM	(8)            /* max input/output streams */

#ifdef RS6000
#define IBMRT
#endif

#if defined(MSDOS) || defined(OS2V2)
#define SMALLER 1
#endif

#ifndef TRUE
#define  TRUE  (1)
#endif
#ifndef FALSE
#define  FALSE (0)
#endif
#ifndef NULL
#define NULL (0)
#endif
#if defined(SYS5) || defined(OS2V2)
#ifndef HZ
#ifndef RS6000
#define HZ 60
#else
#define HZ 100
#endif
#endif
#endif

#if 0
#define MAXPOSINT (2147483647) /*** 2^31 - 1 ***/
#endif
#ifdef CLPR_int
#define MAXPOSINT LONG_MAX
#else
#define MAXPOSINT INT_MAX
#endif

#ifndef fabs
#define fabs(a) ((((double) (a)) > ((double) 0.0)) ? (a) : (-a))
#endif
#ifndef abs
#define abs(a) (((a) > 0) ? (a) : (-a))
#endif
#define is_equal(a, b) (fabs((((double)(a)) - ((double)(b)))) < CLPR_EPS)
#define is_zero(a) (fabs((double) (a)) < CLPR_EPS)

#define  bool    char
#define  loop  for(;;)

extern double CLPR_EPS;
extern CLPR_int CLPR_START_USER_SESSION;
extern  FILE  *popen(const char *, const char *);

typedef CLPR_int *INTptr;
typedef CLPR_int *INSTptr;

#ifdef STATS
#define stats_count(n) CLPR_s_count[n]++;
#else
#define stats_count(n) 
#endif

#if __GNUC__
#define NO_RETURN __attribute__((noreturn))
#else
#define NO_RETURN
#endif

#endif
