:- module fib.

:- interface.

:- import_module io.

:- pred main(io__state::di, io__state::uo) is cc_multi.

:- implementation.
:- import_module cfloat, cfloat_float, float_cfloat.
:- import_module require, int.

main -->
	{ W == 14.0 },
	( 
		{ fib(W, X) }
	->
		io__write_string("Fib(14) = "),
		{ cfloat__get_val(X, XVal) },
		io__write_float(XVal),
		io__write_string("\n")
	;
		io__write_string("oops\nFib(14) died\n")
	),

	{ Z == 610.0 },
	( 
		{ fib(Y, Z) }
	->
		io__write_string("Fib-1(610) = "),
		{ cfloat__get_val(Y, YVal) },
		io__write_float(YVal),
		io__write_string("\n")
	;
		io__write_string("oops\nFib-1(610) died\n")
	).

:- pred fib(cfloat::ca, cfloat::ca) is nondet.

fib(X, Y) :- X == 0.0, Y == 1.0.
fib(X, Y) :- X == 1.0, Y == 1.0.
fib(X, Y) :- X > 1.0, Y = Y1 + Y2, fib(X - 1.0, Y1), fib(X - 2.0, Y2).

