:- module mortgage.

:- interface.

:- import_module io.

:- pred main(io__state::di, io__state::uo) is cc_multi.

:- implementation.
:- import_module list, float, cfloat, cfloat_float, float_cfloat, dump.

main --> main1, main2.
	
:- pred main1(io__state::di, io__state::uo) is cc_multi.
:- pred main2(io__state::di, io__state::uo) is cc_multi.

:- pred goal1(list(cfloat)::list_co, list(string)::out) is cc_nondet.
:- pred goal2(list(cfloat)::list_co, list(string)::out) is cc_nondet.

main1 --> dump_one_solution(goal1).

goal1([P,T,I,B,M], ["P", "T", "I", "B", "M"]) :-
	P == 999999.0,
	T == 360.0,
	I == 0.01,
		% Call mg where B is not constrained.
	mg(P, T, I, B, M).

main2 --> dump_one_solution(goal2).

goal2([P,T,I,B,M], ["P", "T", "I", "B", "M"]) :-
	P == 999999.0,
	T == 360.0,
	I == 0.01,
		% Call mg where B is constrained.
	B == 42.0,
	mg(P, T, I, B, M).

:- pred mg(cfloat, cfloat, cfloat, cfloat, cfloat).
:- mode mg(ca, ca, ca, ca, ca) is nondet. % XXX should be semidet??
:- mode mg(ca, ca, ca, co, ca) is nondet.

mg(P, T, I0, B, MP) :-
	P1 = P * (I0 / 1200.0 + 1.0) - MP,
	( T == 1.0, B == P1
	; T > 1.0, mg(P1, T - 1.0, I0, B, MP)
	).
/*
go1 :- 
	ztime, mg(999999, 360, 0.01, 0, M), ctime(T), 
	printf("Time = %, M = %\n", [T, M]).

go2 :- 
	ztime, mg(P, 720, 0.01, B, M), ctime(T), 
	printf("Time = %\n", [T]),
	dump([P, B, M]).

?- printf("\n>>> Sample goals: go1/0, go2/0\n", []).


split(I1, I2, MP1, MP2, B, P) :- 
	mg(100000, 6, I1/1200, B1, MP1), mg(B1, 6, I2/1200, B, MP2),
	P = 6*MP1 + 6*MP2.

g(MP, B, P) :- split(5, 9.5, MP, MP, B, P).
g(MP, B, P) :- mg(100000, 12, 6.95/1200, B, MP), P = 12*MP.
g(MP, B, P) :- mg(100000, 12, 9.5/1200, B, MP), P = 12*MP.

g(MP) :- g(MP, B, P), dump([B, P]), fail.

*/
