:- module sum_list.

:- interface.

:- import_module io.

:- pred main(io__state::di, io__state::uo) is cc_multi.

:- implementation.

:- import_module list, require, cfloat, cfloat_float, float_cfloat, dump, int.

main --> dump_one_solution(goal).

:- pred goal(list(cfloat)::list_co, list(string)::out) is semidet.
goal([Result], ["Result"]) :-
	make_cfloat_list(40, TheList),
	sum_list(TheList, Result),
	set_list_to_val(1.0, TheList).

:- pred set_list_to_val(float::in, list(cfloat)::list_ca) is semidet.
set_list_to_val(_, []).
set_list_to_val(Val, [X|Xs]) :-
	X == Val,
	set_list_to_val(Val, Xs).

:- pred make_cfloat_list(int::in, list(cfloat)::list_co) is det.
make_cfloat_list(X, Result) :-
	(
		X = 0
	->
		Result = []
	;
		(
			X > 0
		->
			X0 = X - 1,
			cfloat__init(Y),
			make_cfloat_list(X0, Ys),
			Result = [Y|Ys]
		;
			error("ahhhh")
		)
	).

:- pred sum_list(list(cfloat), cfloat).
%:- mode sum_list(list_ca, co) is semidet.
:- mode sum_list(list_ca, ca) is semidet.
sum_list([], X) :- X == 0.0.
sum_list([Y|Ys], X) :-
	X = X0 + Y,
	sum_list(Ys, X0).
