:- module tests.

:- interface.

:- import_module io.

:- pred main(io__state::di, io__state::uo) is cc_multi.

:- implementation.
:- import_module cfloat, cfloat_float, float_cfloat, dump.
:- import_module require, int, std_util.

main -->
	print("test_delaying_1: "),
	( { test_delaying_1 } ->
		print("yes"), nl
	;
		print("no"), nl
	),
	print("test_delaying_2: "),
	( { test_delaying_2 } ->
		print("yes"), nl
	;
		print("no"), nl
	),

	{ create_solvable_delayed_goal(X, Y) },
	print("X = "), dump_cfloat(X), nl,
	print("Y = "), dump_cfloat(Y), nl,

	print("test_delaying_1: "),
	( { test_delaying_1 } ->
		print("yes"), nl
	;
		print("no"), nl
	),
	print("test_delaying_2: "),
	( { test_delaying_2 } ->
		print("yes"), nl
	;
		print("no"), nl
	),

	print("test_delaying_3: "),
	( { create_solvable_delayed_goal(X3, Y3) } ->
		print("yes: X = "), dump_cfloat(X3),
		print(", Y = "), dump_cfloat(Y3), nl
	;
		print("no"), nl
	),
	print("test_delaying_4: "),
	( { create_unsolvable_delayed_goal(X4) } ->
		print("yes: X = "), dump_cfloat(X4), nl
	;
		print("no"), nl
	),
	print("Done.\n").
	
test_delaying_1 :-
	create_solvable_delayed_goal(X, Y),
	wake_and_fail(X, Y).

test_delaying_2 :-
	create_solvable_delayed_goal(X, Y),
	wake_and_succeed(X, Y).

create_solvable_delayed_goal(X, Y) :-
	X = sin(Y).

wake_and_succeed(X, Y) :-
	X == 0.0, Y == 0.0.	% sin(0.0) = 0.0 succeeds.

wake_and_fail(X, Y) :-
	X == 0.0, Y == 1.0.	% sin(0.0) = 1.0 fails.

create_unsolvable_delayed_goal(X) :-
	sin(X) == cos(X) + 42.0.



% :- mode test_modes_1.  (not yet supported)
test_modes_1 :-
	% test auto-initialize (implied free -> any)
	p(_),
	p2(_).

:- mode test_modes_2(in(any)).
test_modes_2(X) :-
	% test implied mode
	q(X).

:- mode p(any -> any) is semidet.
p(_) :- semidet_succeed.

:- mode p2(any -> ground) is failure.
p2(_) :- fail.

:- mode q(free -> any) is det.
q(X) :- cfloat__init(X).
